<?php

namespace DsbNext\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util;
use Teknisa\Libs\Util\NewCode;

class ParametersDashboardController {
    protected $crudService;
    protected $newCode;
    protected $service;
  
    public function __construct($connection, $environment, $util, $crudService, $newCode, $service) {
        $this->connection   = $connection;
        $this->environment  = $environment;
        $this->util         = $util;
        $this->crudService	= $crudService;
        $this->newCode	    = $newCode;
        $this->service      = $service;
    }
  
    public function addProfileAccess(Request\Row $request, Response $response) {
        $row = $request->getParameters();
        try {
            $this->service->beginTransaction();
            
            $nrperfaclpainel = intval($this->newCode->getCodeByTableName("PERFACLPAINEL", $this->environment->getNrOrgTrab()));
            $params = [
              ":P_NRPERFACLPAINEL" => $nrperfaclpainel,
              ":P_NRPAINEL" => $row["NRPAINEL"],
              ":P_NRPERFILACESSO" => $row["NRPERFILACESSO"],
              ":P_CDFILIAL" => $row["CDFILIAL"],
              ":P_IDPADRAODASH" => $row["IDPADRAODASH"],
              ":P_NRORG" => $this->environment->getNrorg()
            ];
            $this->service->insertPerfaclpainel($params);
            
            $this->service->commit();  
        }catch(\Exception $e) {
            $this->service->rollback();
            $response->setError(new Error ($e->getMessage()));
        }
    }
  
   
}