import { Metadata } from '@zeedhi/core';
import {
  Modal,
  ModalService,
  Form,
  GridEditable,
} from '@zeedhi/common';

export class FilterParamDashModalController {
  private filterParamDashModal!: Modal;
  
  public async createFilterParamDashModal() {
    this.filterParamDashModal = await ModalService.createFromJson('/modals/filterParamDashModal', true);
    this.filterParamDashModal.show();
  }
  
  public destroyFilterParamDashModal() {
    this.filterParamDashModal?.destroy();
  }
  
  public openFilterParamDashModal() {
    this.filterParamDashModal.show();
  }
  
  public closeFilterParamDashModal() {
    this.filterParamDashModal.hide();
  }
  
  public applyFilterDash() {
    const filter = Metadata.getInstance<Form>('formFilterParamDash');
    const grid = Metadata.getInstance<GridEditable>('parametersEditGrid');
    const conditions = {
      CDFILIAL: filter.value.CDFILIAL,
      NRPAINEL: filter.value.NRPAINEL,
    };
    if (filter.value.CDFILIAL != null && filter.value.NRPAINEL != null) {
      this.filterParamDashModal.hide();
      grid.datasource.filter = conditions;
      grid.datasource.get();
    }
  }
}
